<template>
  <section class="tasks">
    <div class="tasks__title-block">
      <h1 class="tasks__title">My service like Trello</h1>
    </div>
    <div class="tasks__groups">
      <app-group
        v-for="(group, index) in dataGroup"
        :key="index"
        :data="group"
        class="tasks__group"
        @create:project="createProject"
        @change:groups="updateData"
      />
    </div>
    <app-modal-create
      :data="formattedData"
      :edit="edit"
    />
  </section>
</template>

<script>
import _ from 'lodash';
import { mapGetters } from "vuex";
export default {
  data() {
    return {
      formattedData: null,
      edit: false,
      dataGroup: null
    };
  },
  mounted() {
    this.getData();
    this.dataGroup = _.cloneDeep(this.groups);
    this.$root.$on("edit:project", (e) => {
      this.edit = true;
      this.formattedData = e;
      this.$nextTick(() => {
        this.$bvModal.show("modal-project-" + e.id);
      });
    });
  },
  computed: {
    ...mapGetters({
      groups: "task/items",
    }),
  },
  methods: {
    async getData() {
      try {
        await this.$store.dispatch("task/getTasks");
      } catch (e) {
        console.error(e);
      }
    },
    async updateData() {
      try {
        await this.$store.dispatch("task/editGroups", this.dataGroup);
      } catch (e) {
        console.error(e);
      }
    },
    createProject(e) {
      this.edit = false;
      this.formattedData = e;
      this.$nextTick(() => {
        this.$bvModal.show("modal-project-" + e.id);
      });
    },
  },
  watch: {
    groups: {
      handler(bef) {
        this.dataGroup = _.cloneDeep(bef);
      },
      deep: true,
    },
  },
};
</script>
